//
//  Capusb.m
//  recfx2
//
//  Created by novi on 平成 20/04/22.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

// マックでfriio 
// http://pc11.2ch.net/test/read.cgi/mac/1204674712/
// 
// 317 名前: 105 ￼ Mail: sage 投稿日: 2008/05/11(日) 18:02:26 ID: H3afxfOc0 

// 
//
//  IRmonitor.m
//  IRmonitor
//
//  このプログラムは、Appleの“EzLoader Example”サンプル・コードを元にしています。
//  元のプログラムからの変更点は、以下の通りです。
//
//  ・元々のC言語で書かれたコードを、Objective Cへ移植しました。（事実上、書き直した部分もあります。）
//  ・CocoaアプリケーションのModel Objectとして利用できるように、Notificationやインターフェースを追加しました。
//  ・Intel Hexファイルのサム・チェックを追加しました。
//  ・日本語のコメントを可能な限り追加しました。
//
//  Modified by raktajino on Apr 29 2004.
//  Copyright of the Modification parts : Copyright (c) 2004, raktajino
//

/*
 * Copyright (c) 2003 Apple Computer, Inc. All rights reserved.
 *
 * @APPLE_LICENSE_HEADER_START@
 * 
 * This file contains Original Code and/or Modifications of Original Code
 * as defined in and that are subject to the Apple Public Source License
 * Version 2.0 (the 'License'). You may not use this file except in
 * compliance with the License. Please obtain a copy of the License at
 * http://www.opensource.apple.com/apsl/ and read it before using this
 * file.
 * 
 * The Original Code and all software distributed under the License are
 * distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND APPLE HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
 * Please see the License for the specific language governing rights and
 * limitations under the License.
 * 
 * @APPLE_LICENSE_HEADER_END@
 */

#import "Capsts.h"

static int				THREAD_FLAG = 0;
static int				TIMER_FLAG = 0;

static IONotificationPortRef	fNotifyPort;
static io_iterator_t	fRawAddedIter;
static io_iterator_t	fRawRemovedIter;
static io_iterator_t	fNewDeviceAddedIter;
static io_iterator_t	fNewDeviceRemovedIter;

// レスポンス配列を生成
static USBResponse		res[TS_RESPONSE_SIZE];

// ストアバッファ
static StoreBuffer		_storebuf;

// b25 test
ARIB_STD_B25*			_b25;
B_CAS_CARD*				_bcas;

static BOOL				_useB25;

@implementation Capsts

- (id) init
{
	self = [super init];
	if (self != nil) {
		_useBcas = NO;
		_delegate = nil;
		_useB25 = YES;
	}
	return self;
}

// 割り込みが入ったとき
void SignalHandler(int sigraised)
{
    NSLog(@"- Interrupted -");
	ReleaseB25();
	ReleaseIter();
    _exit(EXIT_SUCCESS);
}

- (void) dealloc
{
	if (_interface) {
		(void) (*_interface)->USBInterfaceClose(_interface);
		(void) (*_interface)->Release(_interface);
	}	
	ReleaseB25();
	ReleaseIter();
	[super dealloc];
}

- (void)setDelegate:(id)delegate {
	_delegate = delegate;
}

- (void) setUseB25:(BOOL)useB25 {
	_useB25 = useB25;
	_b25 = NULL;
	_bcas = NULL;
}


- (enum CONNECT_DEVICE_RETURN)connectDevice {
	
	SInt32	vendor = FX2_VEN;
	SInt32	product = FX2_DEV;
	SInt32	vendor2 = FX2_VEN2;
	SInt32	product2 = FX2_DEV2;
	
	mach_port_t				masterPort = 0;
	CFMutableDictionaryRef  matchingDict = 0;
	CFRunLoopSourceRef		runLoopSource = 0;
	kern_return_t			result;
	
	fNotifyPort = 0;
	fRawAddedIter = 0;
	fRawRemovedIter = 0;
	fNewDeviceAddedIter = 0;
	fNewDeviceRemovedIter = 0;
	
	// 割り込み時の処理
	sig_t oldHandler = signal(SIGINT, SignalHandler);
    if (oldHandler == SIG_ERR) {
        NSLog(@"ERROR : Could not establish new signal handler.");
		//goto bail;
	}
	
	// IOMasterPortを取得する。
	result = IOMasterPort(MACH_PORT_NULL, &masterPort);
	if(result || !masterPort) {
		NSLog(@"ERROR : Could not create a master IOKit Port(%08x).", result);
		goto bail;
	}
	
	// デバイスのマッチング用の辞書を作成する。
	matchingDict = IOServiceMatching(kIOUSBDeviceClassName);
	if(!matchingDict) {
		NSLog(@"ERROR : Could not create a USB matching dictionary.");
		goto bail;
	}
	
	// 辞書にファームウェアのダウンロード時のベンダーIDとプロダクトIDを登録する。
	CFDictionarySetValue(matchingDict,
						 CFSTR(kUSBVendorID), 
						 CFNumberCreate(kCFAllocatorDefault, kCFNumberSInt32Type, &vendor)); 
	CFDictionarySetValue(matchingDict,
						 CFSTR(kUSBProductID), 
						 CFNumberCreate(kCFAllocatorDefault, kCFNumberSInt32Type, &product)); 
	
	// Notification Portを生成し、それをRun Loop Sourceへ登録する。
	fNotifyPort   = IONotificationPortCreate(masterPort);
	runLoopSource = IONotificationPortGetRunLoopSource(fNotifyPort);
	CFRunLoopAddSource(CFRunLoopGetCurrent(), runLoopSource, kCFRunLoopDefaultMode);
	
	// IOServiceAddMatchingNotificationの複数の呼び出しでマッチング用の辞書を共用するので、
	// あらかじめ辞書をRetainしてリファレンスを増やしておく。
	matchingDict = (CFMutableDictionaryRef)CFRetain(matchingDict); 
	matchingDict = (CFMutableDictionaryRef)CFRetain(matchingDict); 
	matchingDict = (CFMutableDictionaryRef)CFRetain(matchingDict); 
	
	// ノーティフィケーションを設定する。
	result = IOServiceAddMatchingNotification(fNotifyPort,
											  kIOFirstMatchNotification,
											  matchingDict,
											  RawDeviceAdded,
											  (void*)self,
											  &fRawAddedIter);
	result = IOServiceAddMatchingNotification(fNotifyPort,
											  kIOTerminatedNotification,
											  matchingDict,
											  RawDeviceRemoved,
											  (void*)self,
											  &fRawRemovedIter);
	RawDeviceRemoved((void*)self, fRawRemovedIter);
	RawDeviceAdded((void*)self, fRawAddedIter);
	
	// 辞書にファームウェアのダウンロード後のベンダーIDとプロダクトIDを登録する。
	CFDictionarySetValue(matchingDict, 
						 CFSTR(kUSBVendorID), 
						 CFNumberCreate(kCFAllocatorDefault, kCFNumberSInt32Type, &vendor2)); 
	CFDictionarySetValue(matchingDict, 
						 CFSTR(kUSBProductID), 
						 CFNumberCreate(kCFAllocatorDefault, kCFNumberSInt32Type, &product2)); 
	
	// ノーティフィケーションを設定する。
	result = IOServiceAddMatchingNotification(fNotifyPort,
											  kIOFirstMatchNotification,
											  matchingDict,
											  NewDeviceAdded,
											  (void*)self,
											  &fNewDeviceAddedIter);
	result = IOServiceAddMatchingNotification(fNotifyPort,
											  kIOTerminatedNotification,
											  matchingDict,
											  NewDeviceRemoved,
											  (void*)self,
											  &fNewDeviceRemovedIter);
	NewDeviceRemoved((void*)self, fNewDeviceRemovedIter);
	NewDeviceAdded((void*)self, fNewDeviceAddedIter);
	
	// IOMasterPortを破棄する。
	mach_port_deallocate(mach_task_self(), masterPort);
	masterPort = 0;
	
	NSLog(@"Waiting for device...");
	// Start the run loop. Now we'll receive notifications.
	CFRunLoopRun();
	
	// ここには来ないが一応
	return CONNECT_DEVICE_SUCCESS;
	
	// Master Port, Matching Dictionary作成失敗
bail:
	//[self dealloc];
	if(masterPort) {
		mach_port_deallocate(mach_task_self(), masterPort);
		masterPort = 0;
	}
	return CONNECT_DEVICE_FAILURE;
}


- (int) sendIRCommand:(UInt16*)aIRCommand Length:(unsigned int)aIRLen {
	
	unsigned int	aCommandRepeat = aIRLen;
	unsigned int	i;
	unsigned long	irWaitTime = IR_WAIT_TIME_NORMAL;
	unsigned int	FX2CommandLength = 0;
	UInt8			FX2CommandBuffer[FX2_COMMAND_BUFFER_SIZE];
	IOReturn		kr;
	
	memset(FX2CommandBuffer, 0, FX2_COMMAND_BUFFER_SIZE);
	
	for(i = 0;i < aCommandRepeat;i++){
		FX2CommandBuffer[FX2CommandLength++] = CMD_IR_CODE;
		FX2CommandBuffer[FX2CommandLength++] = (UInt8)aIRCommand[i];
		FX2CommandBuffer[FX2CommandLength++] = (UInt8)(aIRCommand[i] >> 8);
		kr = (*_interface)->WritePipe(_interface, OUT_END_POINT_SETTING, FX2CommandBuffer, FX2CommandLength);
		if (kIOReturnSuccess != kr)
        {
            NSLog(@"Unable to send commnad1 (%08x).", kr);
            (void) (*_interface)->USBInterfaceClose(_interface);
            (void) (*_interface)->Release(_interface);
            return kr;
        }
		
		FX2CommandLength = 0;
		if(aIRCommand[i] == IR_CMD_3DIGIT_INPUT)
			irWaitTime = IR_WAIT_TIME_3DIGIT;
		usleep(irWaitTime*1000);
		
		FX2CommandBuffer[FX2CommandLength++] = CMD_IR_CODE;
		FX2CommandBuffer[FX2CommandLength++] = 0;
		FX2CommandBuffer[FX2CommandLength++] = 0;
		kr = (*_interface)->WritePipe(_interface, OUT_END_POINT_SETTING, FX2CommandBuffer, FX2CommandLength);
		if (kIOReturnSuccess != kr)
        {
            NSLog(@"Unable to send commnad2 (%08x).", kr);
            (void) (*_interface)->USBInterfaceClose(_interface);
            (void) (*_interface)->Release(_interface);
            return kr;
        }
		FX2CommandLength = 0;
		usleep(IR_WAIT_TIME_SYSTEM*1000);
	}
	
	return 0;
}

- (void) initDevice {
	
	// Capusbを初期化
	IOReturn		kr;
	unsigned int	commandLen = 0;
	UInt8			command[FX2_COMMAND_BUFFER_SIZE];
	
	memset(command, 0, FX2_COMMAND_BUFFER_SIZE);
	
	// 初期化コマンドを作成
	command[commandLen++] = CMD_PORT_CFG;
	command[commandLen++] = 0x00;
	command[commandLen++] = PIO_START | PIO_IR_OUT;
	//command[commandLen++] = CMD_MODE_IDLE;
	//command[commandLen++] = CMD_IFCONFIG;
	//command[commandLen++] = 0xE3;
	command[commandLen++] = 0x70;
	//command[commandLen++] = 0x71;
	
	// 送信
	kr = (*_interface)->WritePipe(_interface, OUT_END_POINT_SETTING, command, commandLen);
	if (kIOReturnSuccess != kr)
	{
		NSLog(@"Unable to init capusbfx2 (%08x).", kr);
		(void) (*_interface)->USBInterfaceClose(_interface);
		(void) (*_interface)->Release(_interface);
	}
	
	// 初期化コマンド2
	commandLen = 0;
	command[commandLen++] = 0x71;
	
	// 送信
	kr = (*_interface)->WritePipe(_interface, OUT_END_POINT_SETTING, command, commandLen);
	if (kIOReturnSuccess != kr)
	{
		NSLog(@"Unable to init capusbfx2 - 2 (%08x).", kr);
		(void) (*_interface)->USBInterfaceClose(_interface);
		(void) (*_interface)->Release(_interface);
	}
	
}


- (void) startRecord {
	
	// 録画開始コマンドを送信
	IOReturn		kr;
	unsigned int	commandLen = 0;
	UInt8			command[FX2_COMMAND_BUFFER_SIZE];
	
	memset(command, 0, FX2_COMMAND_BUFFER_SIZE);
	
	// コマンドを作成
	//command[commandLen++] = 0x70;
	//command[commandLen++] = 0x71;
	//command[commandLen++] = CMD_EP4IN_STOP;
	command[commandLen++] = CMD_EP6IN_START;
	//command[commandLen++] = CMD_EP4IN_START;
	//command[commandLen++] = CMD_PORT_WRITE;
	//command[commandLen++] = PIO_START | PIO_IR_OUT;// | PIO_TS_BACK;
	
	
	// 送信
	kr = (*_interface)->WritePipe(_interface, OUT_END_POINT_SETTING, command, commandLen);
	if (kIOReturnSuccess != kr)
	{
		NSLog(@"Unable to send record commnad (%08x).", kr);
		(void) (*_interface)->USBInterfaceClose(_interface);
		(void) (*_interface)->Release(_interface);
	}
}


- (void) stopRecord {
	//printf("stop start\n");
	
	// 録画停止コマンドを送信
	IOReturn		kr;
	unsigned int	commandLen = 0;
	UInt8			command[FX2_COMMAND_BUFFER_SIZE];
	
	memset(command, 0, FX2_COMMAND_BUFFER_SIZE);
	
	// コマンドを作成
	command[commandLen++] = CMD_EP4IN_STOP;
	command[commandLen++] = CMD_EP6IN_STOP;
	command[commandLen++] = CMD_MODE_IDLE;
	
	// 送信
	kr = (*_interface)->WritePipe(_interface, OUT_END_POINT_SETTING, command, commandLen);
	if (kIOReturnSuccess != kr)
	{
		NSLog(@"Unable to send stop record commnad (%08x).", kr);
		(void) (*_interface)->USBInterfaceClose(_interface);
		(void) (*_interface)->Release(_interface);
	}
}

- (void) powerOn {
	uint16_t		irCommand[FX2_COMMAND_BUFFER_SIZE];
	unsigned int	commandLen = 0;
	
	// 電源ONリモコンコマンド送信
	irCommand[commandLen++] = IR_CMD_POWER_ON;
	[self sendIRCommand:irCommand Length:commandLen];
}

- (void) setChannel:(unsigned int)aChannel channelSource:(enum CH_SOURCE)aSource c3digit:(BOOL)a3digit {
	
	uint16_t		irCommand[FX2_COMMAND_BUFFER_SIZE];
	unsigned int	commandLen = 0;
	uint16_t		irChannel[] = {IR_CMD_CHANNEL_10,
		IR_CMD_CHANNEL_01,
		IR_CMD_CHANNEL_02,
		IR_CMD_CHANNEL_03,
		IR_CMD_CHANNEL_04,
		IR_CMD_CHANNEL_05,
		IR_CMD_CHANNEL_06,
		IR_CMD_CHANNEL_07,
		IR_CMD_CHANNEL_08,
		IR_CMD_CHANNEL_09,
		IR_CMD_CHANNEL_10,
		IR_CMD_CHANNEL_11,
		IR_CMD_CHANNEL_12,
	};
	char			a3digitBuf[4];
	
	// ソースを選択
	switch (aSource) {
		case SOURCE_DIGITAL:
			irCommand[commandLen++] = IR_CMD_SELECT_DT;
			break;
		case SOURCE_BS:
			irCommand[commandLen++] = IR_CMD_SELECT_BS;
			break;
		case SOURCE_CS:
			irCommand[commandLen++] = IR_CMD_SELECT_CS;
			break;
		default:
			return;
			break;
	}
	
	irCommand[commandLen++] = 0;
	
	// 3digitのとき
	if (a3digit == YES) {
		sprintf(a3digitBuf, "%03d",aChannel);
		irCommand[commandLen++] = IR_CMD_3DIGIT_INPUT;
		irCommand[commandLen++] = irChannel[a3digitBuf[0] - 48];
		irCommand[commandLen++] = irChannel[a3digitBuf[1] - 48];
		irCommand[commandLen++] = irChannel[a3digitBuf[2] - 48];
	} else {
		irCommand[commandLen++] = irChannel[aChannel];
	}
	
	// リモコンコマンド送信
	[self sendIRCommand:irCommand Length:commandLen];
	
}

// 録画実行メソッド
// -----------------------------------------------------------
- (enum REC_RETURN)rec:(char*)file withTime:(int)rec_sec
{
	int		b25code;
	
	// b25を使うとき
	if (_useB25 == YES) {
		//NSLog(@"Use b25.");
		
		// b25インスタンス生成
		_b25 = create_arib_std_b25();
		if(_b25 == NULL){
			fprintf(stderr, "error - failed on create_arib_std_b25()\n");
			return REC_B25_ERROR;
		}
		
		// ラウンド数を設定
		b25code = _b25->set_multi2_round(_b25, 4);
		if(b25code< 0){
			fprintf(stderr, "error - failed on ARIB_STD_B25::set_multi2_round() : code=%d\n", b25code);
			return REC_B25_ERROR;
		}
		
		// stripを設定
		b25code = _b25->set_strip(_b25, 1);
		if(b25code < 0){
			fprintf(stderr, "error - failed on ARIB_STD_B25::set_strip() : code=%d\n", b25code);
			return REC_B25_ERROR;
		}
		_b25->set_emm_proc(_b25, 0);	
		
		// B-CASインスタンス生成
		_bcas = create_b_cas_card();
		if(_bcas == NULL){
			fprintf(stderr, "error - failed on create_b_cas_card()\n");
			return REC_BCAS_ERROR;
		}
		
		// bcasを初期化
		b25code = _bcas->init(_bcas);
		if(b25code < 0){
			fprintf(stderr, "error - failed on B_CAS_CARD::init() : code=%d\n", b25code);
			return REC_BCAS_ERROR;
		}
		
		// b25にB-CASを設定
		_b25->set_b_cas_card(_b25, _bcas);
		if(b25code < 0){
			fprintf(stderr, "error - failed on ARIB_STD_B25::set_b_cas_card() : code=%d\n", b25code);
			return REC_BCAS_ERROR;
		}
	}

	// タイマーフラグとスレッドフラグを初期化
	TIMER_FLAG = 1;
	THREAD_FLAG = 1;
	
	// ファイルパスを保存
	file_path = file;
	
	// スレッドを生成
	NSThread *worker = [[NSThread alloc] initWithTarget:self selector:@selector(_recWorker:) object:nil];
	
	// スレッド起動
	[worker start];
	
	// 指定された時間待機
	time_t time_start = time(NULL);
	while(time(NULL) <= time_start + rec_sec) {
		//printf(".");
		// ストアバッファの内容を保存
		storeStoreBuffer(&_storebuf);
		//fflush(stdout);
		usleep(STOREBUFFER_SAVE_INTERVAL);
	}
	
	// タイマーフラグを無効化
	TIMER_FLAG = 0;
	
	// スレッドを待つ
	while(THREAD_FLAG) {
		sleep(1);
	}
	
	// スレッド解放
	[worker release];
	
	// b25解放
	ReleaseB25();
	
	return REC_SUCCESS;
}

// 録画読み込みスレッド用メソッド
// -----------------------------------------------------------
- (void)_recWorker:(id)obj
{
	int					i, RESPONSE_NUM;
	FILE				*output_fd;
	IOReturn			error;
    CFRunLoopSourceRef	cfSource;
	
	/*
	 UInt8					numofendpoints;
	 
	 (*_interface)->GetNumEndpoints(_interface, &numofendpoints);
	 printf("num of end points : %d\n", numofendpoints);
	 
	 
	 IOReturn			ps;
	 UInt8				i8;
	 UInt8				pDirection;
	 UInt8				pNumber;
	 UInt8				pTransType;
	 UInt16				pMaxPacketSize;
	 UInt8				pInterval;
	 
	 
	 for (i8 = 1; i8 <= 0x05; i8++) {
	 ps = (*_interface)->GetPipeStatus(_interface, i8);
	 printf("pipe status for %x : %x\n", i8, ps);
	 (*_interface)->GetPipeProperties(_interface, i8, &pDirection, &pNumber, &pTransType, &pMaxPacketSize, &pInterval);
	 printf("pipe properties for %x D:%x, N:%x, TT:%x, MPS:%x, I:%x\n", i8, pDirection, pNumber, pTransType, pMaxPacketSize, pInterval);
	 
	 }
	 
	 // おまじない
	 (*_interface)->SetAlternateInterface(_interface, 1);
	 (*_interface)->SetAlternateInterface(_interface, 0);
	 */
	
	// 非同期イベントソースの生成
	error = (*_interface)->CreateInterfaceAsyncEventSource(_interface, &cfSource);
	if(error) {
		NSLog(@"_recWorker: Unable to create event source.\n");
		return;
    }
	
	// イベントソースを登録
	CFRunLoopAddSource(CFRunLoopGetCurrent(), cfSource, kCFRunLoopDefaultMode);
	
	// 出力先のファイルデスクリプタを取得
	output_fd = fopen(file_path, "w");
	if(output_fd == NULL) {
		NSLog(@"_recWorker : Unable to open output file.\n");
		CFRunLoopRemoveSource(CFRunLoopGetCurrent(), cfSource, kCFRunLoopDefaultMode);
		THREAD_FLAG = 0;
		return;
	}
	
	// StoreBufferを作成
	initStoreBuffer(STOREBUFFER_SIZE, &_storebuf, &output_fd, _b25);
	
	// バッファの初期化
	for(i=0; i<TS_RESPONSE_SIZE; i++) {
		// インターフェースを初期化
		res[i].interface = _interface;
		// バッファを初期化
		memset(res[i].buffer, '\0', sizeof(res[i].buffer));
		//StoreBuffer初期化
		res[i].sb = &_storebuf;
	}
	
	// パイプ初期化
	error = (*_interface)->ClearPipeStall(_interface, FX2_TS_PIPE);
	if(error) {
		NSLog(@"_recWorker : Could not clear the pipe. (%x)", error);
	}
	
	// 非同期バルク転送
	for(RESPONSE_NUM = 0; RESPONSE_NUM < TS_RESPONSE_SIZE; RESPONSE_NUM++) {
		res[RESPONSE_NUM].resnum = RESPONSE_NUM;
		error = (*_interface)->ReadPipeAsyncTO(_interface, FX2_TS_PIPE, res[RESPONSE_NUM].buffer, TS_BUFFER_SIZE, TS_TIMEOUT_NODATA, TS_TIMEOUT_COMP, (IOAsyncCallback1)_tsWorkerCallback, &res[RESPONSE_NUM]);
		if(error) {
			NSLog(@"_recWorker : Read pipe error. (%d)", RESPONSE_NUM + 1);
			
			// 転送失敗時の後始末
			//return;
			CFRunLoopRemoveSource(CFRunLoopGetCurrent(), cfSource, kCFRunLoopDefaultMode);
			fflush(output_fd);
			fclose(output_fd);
			THREAD_FLAG = 0;
			return;
		}
	}
	
	// イベントループを実行
	CFRunLoopRun();
	
	// イベントループの後処理
	CFRunLoopRemoveSource(CFRunLoopGetCurrent(), cfSource, kCFRunLoopDefaultMode);
	
	// StoreBufferを閉じる
	freeStoreBuffer(&_storebuf);
	
	fflush(output_fd);
	fclose(output_fd);
	
	THREAD_FLAG = 0;
	
}


// 録画読み込みスレッド用コールバック
// -----------------------------------------------------------
void _tsWorkerCallback(USBResponse *readRes, IOReturn result, void *arg) {
	IOReturn error;
	int writeRet;
	
	// コールバック結果のチェック
	if(result != kIOReturnSuccess) {
		NSLog(@"_tsWorkerCallback : Callback failed(%x).", result);
		CFRunLoopStop(CFRunLoopGetCurrent());
		return;
	}
	
	// 非同期Bulk転送を再実行
	error = (*res[readRes->resnum].interface)->ReadPipeAsyncTO(res[readRes->resnum].interface, FX2_TS_PIPE, res[readRes->resnum].buffer, TS_BUFFER_SIZE, TS_TIMEOUT_NODATA, TS_TIMEOUT_COMP, (IOAsyncCallback1)_tsWorkerCallback, &res[readRes->resnum]);
	if(error) {
		NSLog(@"_workerCallback : Read pipe error. (%08x)", error);
	}
	
	// ストアバッファに書き込み
	writeRet = writeStoreBuffer(readRes->buffer, TS_BUFFER_SIZE, &_storebuf);
	
	// ストアバッファがいっぱい
	if (writeRet == STOREBUFFER_BUFFER_FULL) {
		printf("%d : Store Buffer Full!\n", time(NULL));
		//exit(-1);
	}	
	
	// 終了処理
	if(!TIMER_FLAG) {
		CFRunLoopStop(CFRunLoopGetCurrent());
	}
}

- (IOReturn) _findInterfaces:(IOUSBDeviceInterface245**)dev
{
    IOReturn					kr;
    IOUSBFindInterfaceRequest	request;
    io_iterator_t				iterator;
    io_service_t				usbInterface;
    IOCFPlugInInterface			**plugInInterface = NULL;
    IOUSBInterfaceInterface245	**intf = NULL;
    HRESULT						res;
    SInt32						score;
    //CFRunLoopSourceRef			runLoopSource;
    
    request.bInterfaceClass    = kIOUSBFindInterfaceDontCare;
    request.bInterfaceSubClass = kIOUSBFindInterfaceDontCare;
    request.bInterfaceProtocol = kIOUSBFindInterfaceDontCare;
    request.bAlternateSetting  = kIOUSBFindInterfaceDontCare;
	
    kr = (*dev)->CreateInterfaceIterator(dev, &request, &iterator);
    
    while((usbInterface = IOIteratorNext(iterator))) {
		
		NSLog(@"_findInterfaces");
		
        kr = IOCreatePlugInInterfaceForService(usbInterface, kIOUSBInterfaceUserClientTypeID, kIOCFPlugInInterfaceID, &plugInInterface, &score);
        kr = IOObjectRelease(usbInterface);
        if((kIOReturnSuccess != kr) || !plugInInterface) {
            break;
        }
		
        // デバイス・インターフェースから、さらにインターフェースを取得する。
        res = (*plugInInterface)->QueryInterface(plugInInterface, CFUUIDGetUUIDBytes(kIOUSBInterfaceInterfaceID245), (LPVOID) &intf);
		// (*plugInInterface)->Release(plugInInterface);
		IODestroyPlugInInterface(plugInInterface);
        if(res || !intf) {
            break;
        }
        
		// インターフェースをオープンする。
        kr = (*intf)->USBInterfaceOpen(intf);
        if(kIOReturnSuccess != kr) {
            (void) (*intf)->Release(intf);
            break;
        }
		
		//インターフェースをとっておく
		_interface = intf;
		
		// 最初に見つかったインターフェースだけを処理する。
        break;
    }
	return kr;
}

- (IOReturn) _configureAnchorDevice:(IOUSBDeviceInterface245**)dev
{
	//return kIOReturnSuccess;
    UInt8							numConf;
    IOReturn						kr;
    IOUSBConfigurationDescriptorPtr	confDesc;
    
    kr = (*dev)->GetNumberOfConfigurations(dev, &numConf);
    if(!numConf) {
        return -1;
	}
    
    // コンフィグレーション・ディスクリプタを取得する。
    kr = (*dev)->GetConfigurationDescriptorPtr(dev, 0, &confDesc);
    if(kr) {
        return kr;
    }
    kr = (*dev)->SetConfiguration(dev, confDesc->bConfigurationValue);
    if(kr) {
		printf("\tunable to set configuration to value %d (err=%08x)\n", 0, kr);
        return kr;
    }
    return kIOReturnSuccess;
}


- (IOReturn) _downloadToAnchorDevice:(IOUSBDeviceInterface245**)dev
{
	
    UInt8				writeVal;
    IOReturn			kr = noErr;
	FILE				*hexFile;
	INTEL_HEX_RECORD	anchorCode;
    
	NSString *filePath      = [[NSBundle mainBundle] pathForResource:FIRMWARE_FILENAME ofType:@"hex" inDirectory:FIRMWARE_DIR];
	
	hexFile = fopen([filePath fileSystemRepresentation], "r");
    if(hexFile == NULL) goto bail;
	
	NSLog(@"Download a firmware.");
	
    // リセットをアサートする。
    writeVal = 1;
    kr = [self _anchorWrite:dev address:k8051_USBCS length:sizeof(writeVal) data:&writeVal];
    if (kIOReturnSuccess != kr) goto bail;
    
    // ファームウェアをダウンロードする。
    while(1) {
        kr = [self _readHex:&anchorCode fromFile:hexFile];
        if(anchorCode.Type != 0) {
            break;
        }
        if(kr == kIOReturnSuccess) {
            kr = [self _anchorWrite:dev address:anchorCode.Address length:anchorCode.Length data:anchorCode.Data];
        }
        if(kIOReturnSuccess != kr) {
			goto bail;
		}
    }
	
    // リセットをネゲートする。
    writeVal = 0;
    [self _anchorWrite:dev address:k8051_USBCS length:sizeof(writeVal) data:&writeVal];  // 返り値のエラー・コードは無視する。
	
bail:
	if(hexFile != NULL) {
		fclose(hexFile);
	}
	return kr;
}


- (IOReturn) _readHex:(INTEL_HEX_RECORD*)record fromFile:(FILE*)hexFile
{
	// HEXレコードを1行読む。
	unsigned int c1, check;
	SInt32 i, n, len;
	SInt8  sum = 0;
	
    UInt8 c = getc(hexFile);
    if(c != ':') {
        return kIOReturnNotAligned;
    }
	
    n = fscanf(hexFile, "%2lX%4lX%2lX", &record->Length, &record->Address, &record->Type);
    if(n != 3) {
        return kIOReturnNotAligned;
    }
	sum += record->Length;
	sum += record->Type;
	sum += record->Address >> 8;
	sum += record->Address;
    
    len = record->Length;
    if(len > MAX_INTEL_HEX_RECORD_LENGTH) {
        return kIOReturnNotAligned;
	}
    for(i = 0; i<len; i++) {
        n = fscanf(hexFile, "%2X", &c1);
        if(n != 1) {
            if(i != record->Length) {
                return kIOReturnNotAligned;
            }
        }
        record->Data[i] = c1;
		sum += c1;
    }
	
    n = fscanf(hexFile, "%2X\n", &check);
    if(n != 1 || (sum + check) & 0xff != 0x00) {
        return kIOReturnNotAligned;
    }
    return kIOReturnSuccess;
}


- (IOReturn) _anchorWrite:(IOUSBDeviceInterface245 **)dev address:(UInt16)address length:(UInt16)length data:(UInt8*)data
{
    IOUSBDevRequest request;
    request.bmRequestType = USBmakebmRequestType(kUSBOut, kUSBVendor, kUSBDevice);
    request.bRequest      = 0xa0;
    request.wValue        = address;
    request.wIndex        = 0;
    request.wLength       = length;
    request.pData         = data;
    return (*dev)->DeviceRequest(dev, &request);
}

@end


// --- ファームウェアのダウンロード用のデバイスの追加／削除

static void RawDeviceAdded(void *refCon, io_iterator_t iterator)
{
	Capsts               *monitor = (Capsts*)refCon;
    kern_return_t			kr;
    io_service_t			usbDevice;
    IOCFPlugInInterface 	**plugInInterface = NULL;
    IOUSBDeviceInterface245 	**dev = NULL;
    HRESULT					res;
    SInt32					score;
    int						exclusiveErr = 0;
    
	
    while((usbDevice = IOIteratorNext(iterator))) {
		
		NSLog(@"RawDeviceAdded");
		
        kr = IOCreatePlugInInterfaceForService(usbDevice, kIOUSBDeviceUserClientTypeID, kIOCFPlugInInterfaceID, &plugInInterface, &score);
        kr = IOObjectRelease(usbDevice);
        if ((kIOReturnSuccess != kr) || !plugInInterface) {
            continue;
        }
		
        // デバイス・プラグインからデバイス・インターフェースを取得する。
        res = (*plugInInterface)->QueryInterface(plugInInterface, CFUUIDGetUUIDBytes(kIOUSBDeviceInterfaceID245), (LPVOID)&dev);
        (*plugInInterface)->Release(plugInInterface);
        if (res || !dev) {
            continue;
        }
		
        // デバイスをオープンする。
        do {
            kr = (*dev)->USBDeviceOpen(dev);
            if(kIOReturnExclusiveAccess == kr) {
                exclusiveErr++;
                sleep(1);
            }
        } while((kIOReturnExclusiveAccess == kr) && (exclusiveErr < 5));	// 5回まで再試行する。
        if(kIOReturnSuccess != kr) {
            (*dev)->Release(dev);
            continue;
        }
		
        kr = [monitor _configureAnchorDevice:dev];
        if(kIOReturnSuccess != kr) {
            (*dev)->USBDeviceClose(dev);
            (*dev)->Release(dev);
            continue;
        }
		
		// ファームウェアをダウンロードする。
        kr = [monitor _downloadToAnchorDevice:dev];
        if(kIOReturnSuccess != kr) {
            (*dev)->USBDeviceClose(dev);
            (*dev)->Release(dev);
			// ダウンロード失敗
			NSLog(@"A Firmware couldn't download.");
			continue;
        }
		
        // デバイスをクローズする。
		(*dev)->USBDeviceClose(dev);
        (*dev)->Release(dev);
		
		NSLog(@"Firmware loaded.");
    }
}

static void RawDeviceRemoved(void *refCon, io_iterator_t iterator)
{
    kern_return_t	result;
    io_service_t	obj;
    
	
    while((obj = IOIteratorNext(iterator))) {
        result = IOObjectRelease(obj);
		NSLog(@"RawDeviceRemoved");
    }
}

// --- ファームウェアのダウンロード後のデバイスの追加／削除

static void NewDeviceAdded(void *refCon, io_iterator_t iterator)
{
	Capsts               *capsts = (Capsts*)refCon;
    kern_return_t			kr;
    io_service_t			usbDevice;
    IOCFPlugInInterface 	**plugInInterface=NULL;
    IOUSBDeviceInterface245 	**dev=NULL;
    HRESULT					res;
    SInt32					score;
	
	
    while ( (usbDevice = IOIteratorNext(iterator)) )
    {
		NSLog(@"NewDeviceAdded");
		
        kr = IOCreatePlugInInterfaceForService(usbDevice, kIOUSBDeviceUserClientTypeID, kIOCFPlugInInterfaceID, &plugInInterface, &score);
        kr = IOObjectRelease(usbDevice);
        if ((kIOReturnSuccess != kr) || !plugInInterface) {
            continue;
        }
		
        // デバイス・プラグインからデバイス・インターフェースを取得する。
        res = (*plugInInterface)->QueryInterface(plugInInterface, CFUUIDGetUUIDBytes(kIOUSBDeviceInterfaceID245), (LPVOID)&dev);
        (*plugInInterface)->Release(plugInInterface);
        if (res || !dev) {
            continue;
        }
		
        // デバイスをオープンする。
        kr = (*dev)->USBDeviceOpen(dev);
        if (kIOReturnSuccess != kr) {
            (*dev)->Release(dev);
            continue;
        }
		
        kr = [capsts _configureAnchorDevice:dev];
        if (kIOReturnSuccess != kr) {
            (*dev)->USBDeviceClose(dev);
            (*dev)->Release(dev);
            continue;
        }
		
        kr = [capsts _findInterfaces:dev];
        if (kIOReturnSuccess != kr) {
            (*dev)->USBDeviceClose(dev);
            (*dev)->Release(dev);
            continue;
        }
		
		// 非同期で入力を行うので、この時点ではデバイスのクローズはできない。
		// 準備完了を通知
		// ここからメイン処理
		readyDevice(capsts);
    }
}

static void NewDeviceRemoved(void *refCon, io_iterator_t iterator)
{
	//Capusb		*capusb = (Capusb*)refCon;
    kern_return_t	result;
    io_service_t	obj;
    
    while((obj = IOIteratorNext(iterator))) {
        result = IOObjectRelease(obj);
		NSLog(@"NewDeviceRemoved");
    }	
}

static void ReleaseB25(void) {
	if(_b25 != NULL){
		_b25->release(_b25);
		_b25 = NULL;
	}
	
	if(_bcas != NULL){
		_bcas->release(_bcas);
		_bcas = NULL;
	}
}

static void ReleaseIter(void) {
	
	//printf("release iter\n");
	
	if(fNotifyPort) {
		IONotificationPortDestroy(fNotifyPort);
		fNotifyPort = 0;
	}
    if(fRawAddedIter) {
        IOObjectRelease(fRawAddedIter);
        fRawAddedIter = 0;
    }
    if(fRawRemovedIter) {
        IOObjectRelease(fRawRemovedIter);
        fRawRemovedIter = 0;
    }
    if(fNewDeviceAddedIter) {
        IOObjectRelease(fNewDeviceAddedIter);
        fNewDeviceAddedIter = 0;
    }
    if(fNewDeviceRemovedIter) {
        IOObjectRelease(fNewDeviceRemovedIter);
        fNewDeviceRemovedIter = 0;
    }
}